package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.MusicPlayerSingleton;
import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.geometry.Rectangle2D;
import javafx.scene.control.ToggleButton;
import javafx.scene.control.ToggleGroup;
import javafx.scene.image.ImageView;
import javafx.scene.layout.VBox;
import javafx.stage.Screen;

import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class SkinSelectionController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private ToggleGroup selectionButton;
    @FXML
    private ImageView selection1, selection2, selection3;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        selectionButton.selectedToggleProperty().addListener((observableValue, oldToggle, newToggle) -> {
            if (selectionButton.getSelectedToggle() != null) {
                ToggleButton selected = (ToggleButton) selectionButton.getSelectedToggle();
                String value = selected.getText();
                System.out.println(value);
            }
        });
        setImageWidth(selection1, selection2, selection3);
    }

    private void setImageWidth(ImageView... imageViews) { // the ... allows for zero or more arguments seperated by a comma, will pass argument as an array
        Rectangle2D screen = Screen.getPrimary().getVisualBounds();
        final double imageWidth = screen.getWidth() * 0.2;
        for (ImageView image : imageViews) {
            image.setFitWidth(imageWidth);
            image.setPreserveRatio(true);
        }
    }

    @FXML
    private void backButton() {
        parent.getChildren().clear();
        parent.getChildren().add(new SceneLoader().loadScene("LocalCreate"));
    }

    @FXML
    private void gameScene() {


        parent.getChildren().clear();
        parent.getChildren().add(new SceneLoader().loadScene("MapSelection"));
    }
}
