package de.hdm_stuttgart.battlearena.Model.Map;

import javafx.scene.image.Image;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

public class TileFactory {

    private static final Logger log = LogManager.getLogger(TileFactory.class);

    public static ITile createTile(TileType tileType, TileType tileType2, Image tileSprite) {
        if (tileType == TileType.WALKABLE && tileType2 == TileType.DESTRUCTIBLE) {
            log.info("Tile with type: " + tileType + " " + tileType2 + " created.");
            return new BackgroundTile(tileSprite, true, true);
        }else if (tileType == TileType.WALKABLE && tileType2 == TileType.NON_DESTRUCTIBLE) {
            log.info("Tile with type: " + tileType + " " + tileType2 +" created.");
            return new BackgroundTile(tileSprite, true, false);
        }else if (tileType == TileType.NON_WALKABLE && tileType2 == TileType.DESTRUCTIBLE) {
            log.info("Tile with type: " + tileType + " " + tileType2 +" created.");
            return new BackgroundTile(tileSprite, false, true);
        }else if (tileType == TileType.NON_WALKABLE && tileType2 == TileType.NON_DESTRUCTIBLE) {
            log.info("Tile with type: " + tileType + " " + tileType2 +" created.");
            return new BackgroundTile(tileSprite, false, false);
        }

        log.error("TileType: " + tileType + " not supported!");
        throw new IllegalArgumentException("TileType: " + tileType + " not supported!");
    }

}