package de.hdm_stuttgart.battlearena.Model.Multiplayer;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.net.*;
import java.io.*;
import java.util.Arrays;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class Server {

    private static final Logger log = LogManager.getLogger(Server.class);
    private ServerSocket serverSocket;
    private static boolean isServerRunning = true;
    private static int px;
    private static int py;

    private static int enemyx = 0;
    private static int enemyy = 0;
    private static int playerID;
    private static int playercount = 0;
    private static int[] cords;
    private static int[] returncords = {enemyx,enemyy,playerID};
    private boolean started = false;
    private static String ipaddress = "localhost";

//Uncomment these lines to test the server starting manually:
  /*  public static void main(String[] args) throws IOException { //main method for testing purposes
        Server server = new Server();
        log.info("server starting...");
        server.start(ipaddress, 4444);
    } */

    //use this method to start the server from another class
     public void startServer() throws IOException {
        Server server = new Server();
        log.info("server starting...");
        server.start(ipaddress,4444);
    }

    public void start(String host_ip, int port) throws IOException {
        serverSocket = new ServerSocket(port);
        log.info("server started!");
        started = true;
        while (true){
            new ServerHandler(serverSocket.accept()).start();
        }
    }

    private static class ServerHandler extends Thread {
        private final Socket clientSocket;
        private PrintWriter out;
        private BufferedReader in;

        public ServerHandler(Socket socket) {
            this.clientSocket = socket;
        }

        public void run() {
            ScheduledExecutorService executorService = Executors.newSingleThreadScheduledExecutor();

            executorService.scheduleAtFixedRate(() -> {
                try {
                    BufferedReader localIn = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
                    PrintWriter localOut = new PrintWriter(clientSocket.getOutputStream(), true);

                    String inputLine = localIn.readLine();

                    if (inputLine != null) {
                        // Assuming that the input line is a comma-separated list of integers
                        String[] coordinates = inputLine.split(",");
                        cords = new int[coordinates.length];
                        for (int i = 0; i < coordinates.length; i++) {
                            cords[i] = Integer.parseInt(coordinates[i]);
                        }

                        //first connect of a client:
                        if(playercount == 0){
                            //first player to connect
                            playercount++;
                            returncords[2] = 1;

                        } else if(playercount == 1){
                            //second player to connect
                            if(cords[2] == 1){
                                returncords[2] = 1;
                            } else {
                                playercount++;
                                returncords[2] = 2;
                            }

                        } else if(playercount == 2){

                            //check which client has connected
                            if (cords[2] == 1) { //player
                                px = cords[0];
                                py = cords[1];

                                //set the cords to return:
                                returncords[0] = enemyx;
                                returncords[1] = enemyy;

                                //set playerID:
                                returncords[2] = 1;

                            } else if(cords[2] == 2) { //enemy
                                enemyx = cords[0];
                                enemyy = cords[1];

                                //set the cords to return:
                                returncords[0] = px;
                                returncords[1] = py;

                                //set playerID:
                                returncords[2] = 2;

                            }
                        }

                        localOut.println(Arrays.toString(returncords));
                        localOut.flush();
                    }

                    log.info("Player X / Y : " + px + " / " + py + " Enemy X / Y : " + enemyx + " / " + enemyy);


                    //check if server was shut down:
                    if (!isServerRunning) {
                        executorService.shutdown();
                        try {
                            if (!executorService.awaitTermination(5, TimeUnit.SECONDS)) {
                                executorService.shutdownNow();
                            }
                        } catch (InterruptedException e) {
                            log.error("Error waiting for executor service termination: " + e.getMessage());
                        }
                    }

                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }, 0, 50, TimeUnit.MILLISECONDS);
        }
    }

    public void stopServer() {
        isServerRunning = false;
        try {
            serverSocket.close(); // Close the server socket to break out of accept() in the main thread
        } catch (IOException e) {
            log.error("Error closing server socket: " + e.getMessage());
        }
    }

    public boolean isStarted() {
        return started;
    }
    public static void setIpaddress(String ipaddress) {
        Server.ipaddress = ipaddress;
    }
}
